from .. import worker
from ..segments import *

def get_variable(type, value):
  v = value
  class blockbee_variable(worker):
    inp = antenna("push",type)
    value = variable(type)
    startvalue(value, v)
    connect(inp, value)
    outp = output("pull",type)
    connect(value, outp)
    trig = output("push", "trigger")
    trigger(value, trig, "input")
  return blockbee_variable

def get_link(mode,type):
  class blockbee_link(worker):
    inp = antenna(mode,type)
    outp = output(mode,type)
    connect(inp, outp)
  return blockbee_link

def get_transistor(type):
  class blockbee_transistor(worker):
    inp = antenna("pull",type)
    trig = antenna("push", "trigger")
    outp = output("push",type)
    t = transistor(type) 
    connect(inp,t)
    trigger(trig, t)    
    connect(t, outp)
  return blockbee_transistor

def get_triggered(type):
  class blockbee_triggered(worker):
    inp = antenna("push",type)
    v = buffer("push",type)
    connect(inp, v)    
    trig = output("push","trigger")
    trigger(v, trig)
  return blockbee_triggered
