import libcontext
from . import spyderhive
import spyder, Spyder

from .. import connect, frame
from .spyderhive import SpyderMethod, SpyderConverter

from ..block import intern as block_intern, extern as block_extern
from .blockbee import blockbee_build

def make_hivemap(ng):
  d = {}
  __makehivemap_workers__ = {}
  for worker in ng.workers:
    lastdot = worker.workertype.rindex(".")
    modname = worker.workertype[:lastdot]
    workername = worker.workertype[lastdot+1:]
    __makehivemap_worker0 = {}
    __makehivemap_worker00__ = __import__(modname, __makehivemap_worker0, __makehivemap_worker0, [workername])
    __makehivemap_workers__[worker.workertype] = getattr(__makehivemap_worker00__,workername)
  class maphive(frame):
    __makehivemap_worker = None
    for worker in ng.workers:
      if worker.metaparameters != None:
        metaparamdict = dict([(p.pname,p.pvalue) for p in worker.metaparameters])
        for k in list(metaparamdict.keys()): 
          if metaparamdict[k] == "None": metaparamdict[k] = None
        __makehivemap_worker = __makehivemap_workers__[worker.workertype](**metaparamdict)
      else:
        __makehivemap_worker = __makehivemap_workers__[worker.workertype]
      __makehivemap_p = {}
      if worker.parameters != None: 
        for param in worker.parameters: 
          v = param.pvalue
          if v == "None": v = None
          __makehivemap_p[param.pname] = v
      locals()[worker.workerid] = __makehivemap_worker(**__makehivemap_p)
    for block in ng.blocks:
      if block.mode == "intern": newblockclass = block_intern
      elif block.mode == "extern": newblockclass = block_extern
      spyder.load(block.spyderclass)
      spyderclass = getattr(Spyder,  block.spyderclass)
      newblock = newblockclass(spyderclass)
      locals()[block.blockid] = newblock
    for bbworker in ng.blockbeeworkers:
      locals()[bbworker.workerid] = blockbee_build(bbworker.blockbee[0])()
    for con in ng.connections:
      connect((con.start.workerid, con.start.io), (con.end.workerid, con.end.io))
    blocks = [(w.blockid, w) for w in ng.blocks]
    blocks += [(w.workerid,w) for w in ng.blockbeeworkers]
    blocks = dict(blocks)
    for con in ng.blockconnections:
      source = con.start.workerblockid
      if len(con.start.io): 
        sio = tuple(con.start.io)
        if len(sio) == 1 and con.start.proxyform:
          sobj = blocks[source]
          sio = (sobj.proxy(sio[0]),)
        source = (source,) + sio
      target = con.end.workerblockid
      if len(con.end.io): 
        tio = tuple(con.end.io)
        if len(tio) == 1 and con.end.proxyform:
          tobj = blocks[target]
          tio = (tobj.proxy(tio[0]),)
        target = (target,) + tio      
      connect(source, target)
    del __makehivemap_worker      
  return maphive().getinstance()

class hivemapframe(spyderhive.spyderframe):
  SpyderMethod("make_bee", "Hivemap", make_hivemap)  
  
class hivemaphive(spyderhive.spyderhive):
  SpyderMethod("make_bee", "Hivemap", make_hivemap)  

class hivemapinithive(spyderhive.spyderinithive):
  SpyderMethod("make_bee", "Hivemap", make_hivemap)  
