"""
This file is NOT covered by the dual license as described in LICENSE.txt
"""

from ..hivemodule import *
from .. import hivemodule
from ..configure import configure_base

from .. import emptyclass, mytype, myobject

class spyderwrapper(myobject):
  def __init__(self, obj):
    self.obj = obj
    self.combined = False    
  def set_parameters(self, parameters):
    pass
  def getinstance(self): 
    return self.obj
  def __getattr__(self, attr):
    return getattr(self.obj, attr)
       
def filter_spyderreg(arg): 
  if hasattr(arg, "typename") and hasattr(arg.typename, "__call__") and isinstance(arg.typename(), str): return spyderwrapper(arg)
  return None

def spyderresultwrapper(l):  
  class spyderconfigureclass(configure_base):
    def __init__(self, l):
      self.l = l
    def configure(self,*arg):
      for i in self.l: 
        i.configure(*arg)
    def hive_init(self,*arg):
      for i in self.l: 
        i.hive_init(*arg)
    def place(self): 
      pass    
  
  class spyderplaceclass(object):
    def __init__(self, l):
      self.l = l
    def place(self):
      for i in self.l: 
        i.place()
    def getinstance(self): return self
    
  has_conf = True
  has_place = True
  ll = []  
  for o in l:
    if isinstance(o, configure_base):
      no_conf0 = False
      no_place0 = True
    else:
      no_conf0 = not hasattr(o, "configure") or not hasattr(o.configure,"__call__") or not hasattr(o, "hive_init") or not hasattr(o.hive_init,"__call__")
      no_place0 = not hasattr(o, "place") or not hasattr(o.place,"__call__")
    if no_conf0 and no_place0:
      if not isinstance(o, list):
        raise TypeError("Spyderobject .make_bee() result has neither configure()/hive_init() nor place()")
      else: 
        o = spyderresultwrapper(o)
        no_conf0 = not hasattr(o, "configure") or not hasattr(o.configure,"__call__") or not hasattr(o, "hive_init") or not hasattr(o.hive_init,"__call__")
        no_place0 = not hasattr(o, "place") or not hasattr(o.place,"__call__")   
        ll.append(o)        
    else: 
      ll.append(o)
    if no_conf0: has_conf = False          
    if no_place0: has_place = False
  if not has_conf and not has_place:
    raise TypeError("Spyderobject .make_bee() results have neither all configure()/hive_init() nor all place()")
  if has_conf and has_place: 
    raise TypeError("Spyderobject .make_bee() results have all configure()/hive_init() and place()")
  if has_conf: return spyderconfigureclass(ll)
  if has_place: return spyderplaceclass(ll)

  raise Exception #should never happen...
    
class reg_spydermethod_or_converter(mytype): 
  reg = {}
  def __new__(cls, name, bases, dic):
    if name not in ("spydermethod_or_converter",) and "__init__" in dic:
      dic["__init__old__"] = dic["__init__"]
      dic["__init__"] = reg_spydermethod_or_converter.register(dic["__init__"])
    return type.__new__(cls,name,bases,dic)
  @classmethod
  def register(cls, initfunc):
    def init(self, *args, **kargs):
      fr = id(inspect.currentframe().f_back.f_back)
      if fr not in cls.reg: cls.reg[fr] = []
      cls.reg[fr].append(self)
      return self.__init__old__(*args, **kargs)
    return init

class spydermethod_or_converter(myobject):
  __metaclass__ = reg_spydermethod_or_converter
  
def get_spydermethod_or_converter_reg(fr, dicvalues):
  ret = []
  if fr in reg_spydermethod_or_converter.reg:
    ret = [spyderwrapper(a) for a in reg_spydermethod_or_converter.reg[fr] if a not in dicvalues]
    del reg_spydermethod_or_converter.reg[fr]
  return ret
  
def filter_spydermethod_or_converter_reg(a):
  if isinstance(a, spydermethod_or_converter): return spyderwrapper(a)

class _spyderhivebuilder(hivemodule._hivebuilder):
  __registers__ = [get_spydermethod_or_converter_reg ]
  __registerfilters__ = [filter_spyderreg, filter_reg_beehelper, filter_spydermethod_or_converter_reg, filter_evwrapper]
  
_spyderhivebuilder.__thisclass__ = _spyderhivebuilder

class spyderhivecontextmixin(myobject):
  def __init__(self, *args, **kargs):
    self.buildmodifiers.append(self.process_spyderobjects)
  def process_spyderobjects(self, arg):
    spyder_indices = []
    converter_indices = []
    for onr, o in enumerate(arg.bees):
      obj = o[1]        
      if hasattr(obj, "typename") and hasattr(obj.typename,"__call__") and isinstance(obj.typename(), str):
        spyder_indices.append(onr)
      if isinstance(obj, spydermethod_or_converter): 
        converter_indices.append(onr)
    for onr in converter_indices:
      arg.bees[onr][1].func.enable()
    for onr in spyder_indices:
      r = arg.bees[onr][1].make_bee()
      if hasattr(r, "place") and hasattr(r.place, "__call__"):
        pass         
      elif hasattr(r, "configure") and hasattr(r.configure, "__call__"):
        pass                   
      elif hasattr(r, "hive_init") and hasattr(r.hive_init, "__call__"):
        pass                   
      elif isinstance(r, list):                
        r = spyderresultwrapper(r)
      else:
        raise TypeError("Spyderobject.make_bee() => %s does not have a method place() nor configure() nor hive_init()\nSpyderobject:\n%s" % (r, arg.bees[onr][1]))
      arg.bees[onr] = (arg.bees[onr][0], r)
    for onr in converter_indices:
      arg.bees[onr][1].func.disable()
    arg.bees = [o for onr, o in enumerate(arg.bees) if onr not in converter_indices]
   
class spyderhivecontext(spyderhivecontextmixin, hivecontext):
  def __init__(self, *args, **kargs):    
    hivecontext.__init__(self,*args, **kargs)
    spyderhivecontextmixin.__init__(self,*args, **kargs)
    
class spyderinithivecontext(spyderhivecontextmixin, inithivecontext):
  def __init__(self, *args, **kargs):
    inithivecontext.__init__(self,*args, **kargs)
    spyderhivecontextmixin.__init__(self,*args, **kargs)

class spyderhive(closedhive,emptyclass):
  __metaclass__ = _spyderhivebuilder
  _hivecontext = spyderhivecontext  

class spyderframe(frame,emptyclass):
  __metaclass__ = _spyderhivebuilder
  _hivecontext = spyderhivecontext  
  
class spyderinithive(closedhive,emptyclass):
  __metaclass__ = _spyderhivebuilder
  _hivecontext = spyderinithivecontext  
  
class SpyderConverter(spydermethod_or_converter):
  def __init__(self, intype, outtype, converterfunc):
    from .. import spy
    import spyder
    self.func = spyder.core.defineconverter(intype, outtype, converterfunc)
    self.func.disable()

class SpyderMethod(spydermethod_or_converter):
  def __init__(self, methodname, spydertype, methodfunc):
    from .. import spy
    import spyder
    self.func = spyder.core.definemethod(methodname, spydertype, methodfunc)
    self.func.disable()
  
