import libcontext
from libcontext import subcontext as hivecontext

class _initbee(object):
  def __init__(self):
    self.initfuncs = []
  def add_init(self, func):
    self.initfuncs.append(func)
  def init(self):
    for f in self.initfuncs: f()

class inithivecontext(hivecontext):
  def __init__(self, *args, **kargs):
    self._initbee = _initbee()
    hivecontext.__init__(self, *args, **kargs)
  def __place2__(self):
    socketclass = libcontext.socketclasses.socket_supplier    
    libcontext.socket(("bee", "init"), socketclass(self._initbee.add_init))
    hivecontext.__place2__(self)
  def init(self):
    self._initbee.init()
    self.hive_init()
    
class apphivecontext(inithivecontext):
  def __init__(self, *args,**kwargs):
    inithivecontext.__init__(self,*args,**kwargs)
    self.app = self.appbee.getinstance()    
  def __getattr__(self, attr):
    try:
      return getattr(self.app, attr)      
    except AttributeError:
      return inithivecontext.__getattr__(self, attr)
  def set_parent(self, parent):
    inithivecontext.set_parent(self, parent)
    self.app.parent = self
  def __place2__(self):        
    self.app.place()    
    inithivecontext.__place2__(self)
  def init(self):
    inithivecontext.init(self)
    try:
      i = self.app.init
    except AttributeError:
      pass
    else:
      if not isinstance(i, str) or isinstance(i, tuple): i()

def appcontext(appbee, *args, **kwargs):
  return type("appcontext", (apphivecontext,),{"appbee":appbee(*args, **kwargs)})
