from __future__ import print_function

import bee

from bee.pin import pinworker, inputpin, outputpin
from bee.morph import morph, morphhive

import libcontext
libcontext.use_networks = False

#Definition of some pin workers
class int_variable(pinworker):
  o = outputpin("pull","int")
  def run(self):
    pass

class addworker(pinworker):
  i1 = inputpin("pull", "int")
  i2 = inputpin("pull", "int")
  o = outputpin("pull", "int")
  def run(self): 
    self.o.value = self.i1.value + self.i2.value

class andworker(pinworker):
  i1 = inputpin("pull", "bool")
  i2 = inputpin("pull", "bool")
  o = outputpin("push", "trigger")
  def run(self): 
    if self.i1.value and self.i2.value: 
      self.o.value = True
    else:
      self.o.value = False

#Definition of a morph
class operate_morph(morph):
  slots = {
    "var1": ( [], ["int"] ),
    "var2": ( [], ["int"] ),
    "op": ( ["int", "int"], ["int"] ),
  }
  result = outputpin("pull", "int")  
  def run(self):
    v1 = self.morphs["var1"].outputs[0]
    print("RETRIEVE VAR1:", v1)
    self.morphs["op"].inputs[0] = v1

    v2 = self.morphs["var2"].outputs[0]
    print("RETRIEVE VAR2:", v2)    
    self.morphs["op"].inputs[1] = v2

    self.morphs["op"].run()

    result = self.morphs["op"].outputs[0]
    print("RESULT", result)
    self.result.value = result


from bee import connect
class main(morphhive):
  #all of the bees below are created dynamically!
  # so the static creation is commented out...
  """
  v1 = int_variable()
  v2 = int_variable()
  add = addworker()

  m = operate_morph()
  """
  pass

  
h = main().getinstance()
h.build("main")
h.place()
h.close()
h.init()

#START

#we create all pinworkers and morphs dynamically
h.v1 = h.create(int_variable(), "v1")
h.v2 = h.create(int_variable(), "v2")
h.add = h.create(addworker(), "add")
h.m = h.create(operate_morph(), "m")

#we set the two variables to 5 and 10
h.v1.o.value = 5
h.v2.o.value = 10

#we dock the two variables into the morph
h.m.dock("var1", h.v1)
h.m.dock("var2", h.v2)
#we dock the add worker into the morph
h.m.dock("op", h.add)

#we run the morph
h.m.run()
print(h.m.result.value)

