#Code to define the hive:
# (depends only on BSD portions)

import dragonfly, dragonfly.io, dragonfly.sys
import bee
import appcontext
import libcontext

from bee.worker import workerframe
import dragonfly.consolehive.inputhandler
import dragonfly.time
import bee.eventhandler

class appinit(bee.drone):
  def place(self):
    s = libcontext.socketclasses.socket_container(app.add_init)
    libcontext.socket(("bee","init"), s)

class appclass(dragonfly.consolehive.consoleapp, appcontext._initbee):
  def __init__(self):
    dragonfly.consolehive.consoleapp._wrapped_hive.__init__(self)
    appcontext._initbee.__init__(self)

bees = dict(
  __app__ = appclass(),
  #Drones
  d1 = appinit(),
  d2 = bee.eventhandler.eventhandler(),
  d3 = dragonfly.consolehive.inputhandler.inputhandler(),
  d4 = dragonfly.time.pacemaker_simple(),
  d5 = dragonfly.time.simplescheduler(),
  #Workers
  w1 = dragonfly.io.keyboardsensor_trigger("ESCAPE"),
  w2 = dragonfly.sys.exitactuator(),
)

connections = [
  ( ("w1", ("bee","output", "outp", "trigger")), 
    ("w2", ("bee","antenna", "inp", "trigger")),
  ),
  ( ("d1", ("bee","init")), 
    ("w1", ("bee","init")),
  ),
  ( ("w1", ("evin","add_listener")), 
    ("d2", ("evin","add_listener")),
  ),
  ( ("w1", ("evin","remove_listener")), 
    ("d2", ("evin","remove_listener")),
  ),
  ( ("w1", ("evin",("input", "keyboard"))),
    ("d3", ("evout",("input", "keyboard"))),
  ),
  ( ("__app__", "cleanupfunction"), 
    ("d3", "cleanupfunction"),
  ),
  ( ("__app__", "startupfunction"), 
    ("d3", "startupfunction"),
  ),
  ( ("__app__", "pacemaker"), 
    ("d4", "pacemaker"),
  ),
  ( ("d4", ("evin","event")), 
    ("d2", ("evin","event")),
  ),
  ( ("d5", ("evin","event")), 
    ("d2", ("evin","event")),
  ),
  ( ("d2", ("evin","listener")), 
    ("d5", ("evin","listener")),
  ),
  ( ("d3", ("evout","scheduler")), 
    ("d5", ("evin","scheduler")),
  ),
  ( ("w2", "exit"), 
    ("__app__", "exit"),
  ),

]

#Code to run the hive:

import libcontext.network
libcontext.network.disable()

main = libcontext.context("main")
app = None

libcontext.push("main")

beecontexts = {}
for name in bees:
  b = bees[name].getinstance()
  if isinstance(b, workerframe): 
    b.build(name)
    b.place()
    c = b.context
  else:
    c = libcontext.context(name)
    libcontext.push(name)
    b.place()
    libcontext.pop()
    if name == "__app__": app = b
  beecontexts[name] = c

for s, p in connections:
  sbee, sname = s
  pbee, pname = p
  sc = beecontexts[sbee]
  pc = beecontexts[pbee]
  pc.import_socket(sc, sname, pname)
  sc.import_plugin(pc, pname, sname)
  
libcontext.pop()
main.close()
app.init()

print "Starting up test hive, press ESC to quit"
app.run()
