import libcontext
from libcontext.socketclasses import *
from libcontext.pluginclasses import *

from ..canvas import canvasdrone
from .blendercanvas_bgrid import blendercanvas_bgrid
from .blendercanvas_mstr import blendercanvas_mstr
from .blendercanvas_image import blendercanvas_image
import functools

blendercanvasinstances = set((0,))

class blendercanvas(canvasdrone,
                  blendercanvas_bgrid,
                  blendercanvas_mstr,
                  blendercanvas_image,
                 ): #call place() explicitly for all mixins!
  classname = "blenderclass"
  def __init__(self):
    global blendercanvasinstances
    self.instances = {}
    self.canvasinstance = max(blendercanvasinstances)+1
    blendercanvasinstances.add(self.canvasinstance)
    self._render2d = None
    self._aspect2d = None
    self._pixel2d = None

  def get_canvas_size(self, canvas_sizefunc):
    self.canvas_size = canvas_sizefunc

  def _set_render2d(self,get_render2d):
    self.get_render2d = get_render2d
  def _set_aspect2d(self,get_aspect2d):
    self.get_aspect2d = get_aspect2d
  def _set_pixel2d(self,get_pixel2d):
    self.get_pixel2d = get_pixel2d
  @staticmethod
  def canvas_size():
    import bge 
    x = bge.render.getWindowWidth()
    y = bge.render.getWindowHeight()
    return x,y
    
  def place(self):
    oldplugs = self._get_oldplugins()    
    libcontext.socket(("blender", "noderoot", "pixel2d"), socket_single_required(self._set_pixel2d))
    libcontext.socket(("blender", "noderoot", "render2d"), socket_single_required(self._set_render2d))
    libcontext.socket(("blender", "noderoot", "aspect2d"), socket_single_required(self._set_aspect2d))
    libcontext.plugin(("canvas","size"), plugin_supplier(self.canvas_size))

    #super() and stuff doesn't work, call place() explicitly for each mixin
    blendercanvas_bgrid.place(self)
    blendercanvas_mstr.place(self)
    blendercanvas_image.place(self) 

    #finally, call canvasdrone.place
    canvasdrone._wrapped_hive.place(self,oldplugs)
