from __future__ import print_function

maxtup = (99999,)*999

def report(*args):
  #print(*args)
  pass

def namesortfunc(name):
  if isinstance(name, tuple):
    strings = ()
    numbers = ()
    for r in name:
      n,s = namesortfunc(r)
      numbers += n
      strings += s
    ret = (numbers, strings)
  else:
    name = encode_context(name)
    if isinstance(name,str): name = (name,)
    ret = ((len(name),), name)
  #if len(ret[0]) == 1 and ret[1] == ("evexc",): 
  #  return (maxtup, ("ZZZevexc",))
  return ret

def bee_evexc(nam):
  if not isinstance(nam, tuple): return False
  if not len(nam): return False
  if nam == ("bee","init"): return False
  return nam[0] in ("bee", "evexc")

from .network import network, networks

def find_subcontexts(context):
  from . import _contexts as contexts, get_curr_contextname, _all_connections
  currcontextname = encode_context(context.contextname)
  subcontextnames = [k for k in contexts.keys() if len(k) > len(currcontextname) and k[:len(currcontextname)] == currcontextname]
  subcontextnames.sort(key = namesortfunc)  
  subcontexts = []
  for subcontextname in subcontextnames: 
    for n in range(len(currcontextname)+1, len(subcontextname)):
      if subcontextname[:n] in contexts: break
    else:
      subcontexts.append(contexts[subcontextname])
  return subcontexts
 
def retrieve_plugins(context, plugin, visited=[]):
  if context in networks and \
   context is networks[context].contexts[-1] and \
   not bee_evexc(plugin):
    #report("RESOLVE!", context.contextname)
    networks[context].resolve()
    context.retrieved_plugins = {}
  try:
    return context.retrieved_plugins[plugin]
  except KeyError:
    pass

  ret = None
  if plugin in context.plugins: 
    ret = [(context.contextname, p) for p in context.plugins[plugin]]
  for contextinstance, name, newname, optional in context.plugin_imports:
    if contextinstance in visited: continue
    #report(name,newname, plugin)
    if newname == plugin: 
      if ret is None: ret = []
      newvisited = list(visited)
      newvisited.append(context)           
      #report("TRY!", contextinstance.contextname, name)
      ret2 = retrieve_plugins(contextinstance, name, newvisited)
      if ret2 != None: ret += ret2
  context.retrieved_plugins[plugin] = ret
  return ret

def retrieve_sockets(context, socket, visited=[]):
  if context in networks and \
   context is networks[context].contexts[-1] and \
   not bee_evexc(socket):
    networks[context].resolve()
    context.retrieved_sockets = {}
    ret = context.sockets.get(socket, None)
    if ret is None: return ret
    return [(context.contextname, s) for s in ret]
  try:
    return context.retrieved_sockets[socket]
  except KeyError:
    pass

  ret = None
  if socket in context.sockets: 
    ret = [(context.contextname, s) for s in context.sockets[socket]]
  for contextinstance, name, newname, optional in context.socket_imports:
    if contextinstance in visited: continue       
    if newname == socket: 
      if ret is None: ret = []
      newvisited = list(visited)
      newvisited.append(context)  
      ret2 = retrieve_sockets(contextinstance, name, newvisited)      
      if ret2 != None: ret += ret2
  context.retrieved_sockets[socket] = ret
  return ret
  
import sys
python2 = (sys.version_info[0] == 2)
python3 = (sys.version_info[0] == 3)

import traceback
from . import socket_base, plugin_base

#at runtime, you can get the context name of a socket or plugin: 
#x.im_self.workerinstance._context.contextname
#
#you can retrieve all targets from a push outputpin socket as:
#x.function.im_self.outputs

def do_raise(e):
  exec("raise type(e), e, sys.exc_info()[2]")
  
def namesortfunc2(c):
  name = c[0]
  name = encode_context(name)
  if isinstance(name,str): name = (name,)
  return (len(name), name)


def flatten(k):
  ret = []
  for i in k:
    if isinstance(i, str): ret.append(i)
    elif isinstance(i, tuple): ret += flatten(i)
    else: raise TypeError(i)
  return ret

def decode_context(contextargs):
  try:
    len(contextargs)
  except TypeError:
    raise TypeError("Context '%s' must be string or tuple, not %s" % (contextargs, contextargs.__class__.__name__))
  if len(contextargs) == 0: 
    raise TypeError("Context must have an identifier")
  ret = contextargs
  if len(contextargs) == 1:
    if hasattr(contextargs[0], "decode") or hasattr(contextargs[0], "encode"): ret = contextargs[0]
  for s in ret:
    if not hasattr(s, "decode") and not hasattr(s, "encode"): raise TypeError("Invalid context %s" % str(contextargs))
  return ret

def encode_context(contextargs):
  if hasattr(contextargs, "decode") or hasattr(contextargs, "encode"): 
    contextargs = (contextargs,)
  return contextargs


class context(object):
  import_all_from_parent = False
  import_parent_sockets = []
  import_parent_plugins = []
  import_parent_sockets_optional = []
  import_parent_plugins_optional = []  
  import_parent_skip = []
  parent_exported = False
  priority = 0
  connection = None
  subcontext = None
  def __init__(self,*contextargs,**kwargs):
    absolute = False
    if "absolute" in kwargs: absolute = kwargs["absolute"]
    from . import abscontextname, register_context
    self.contextname = decode_context(contextargs)
    if not absolute: self.contextname = abscontextname(self.contextname)    
    self.sockets = {}
    self.plugins = {}
    self.socket_imports = []
    self.plugin_imports = []
    self.import_origins_plugins = {}
    self.import_origins_sockets = {}
    register_context(self.contextname, self)
    self.preclose_functions = []
    self.postclose_functions = []
    self.closed = False    

    self.retrieved_plugins = {}
    self.retrieved_sockets = {}    
    
    self._postinit()
  def _postinit(self):
    pass
  def __overwriting__(self, oldcontextinstance):    
    raise Exception("Cannot register context %s: context already exists" % str(self.contextname))
  def __overwritten__(self, newcontextinstance):
    pass
  def context(self, contextname, contextinstance):
    contextname = decode_context(contextname)
    register_context(self.contextname + contextname, contextinstance)

  def parent_export(self):   
   report("PARENT-EXPORT", self.contextname)
   if self.parent_exported: return   
   subcontexts = find_subcontexts(self)
   for s in subcontexts: s.parent_export()
   self.parent_exported = True
   self.parent_do_export()

  
  def parent_import(self):   
   report("PARENT-IMPORT", self.contextname)
   self.parent_do_import()   
   subcontexts = find_subcontexts(self)
   for s in subcontexts: s.parent_import()
  
   
  def parent_do_export(self):
    report("PARENT-DO-EXPORT", self.contextname)  
    from . import _contexts as contexts, get_curr_contextname, _all_connections
    if not self.import_all_from_parent: return   
    if self in networks: return
    #report("PARENT-EXPORT", self.contextname)
    #report(self.plugins.keys(), [p[2] for p in self.plugin_imports])
    #report(self.sockets.keys(), [p[2] for p in self.socket_imports])
    #report("")

    parent = None
    myname = self.contextname        
    while True:
      myname = myname[:-1]
      if not len(myname): break
      if myname in contexts:
        parent = contexts[myname]
        break

    if parent is None: return
    nw = False
    if parent in networks:
      nw = True
      parent_old = parent
      parent = networks[parent]
      parent.orig = parent_old


    for sock in sorted(self.sockets,key=namesortfunc):
      if bee_evexc(sock): 
        continue
      parent.import_socket(self, sock)
    for plug in sorted(self.plugins,key=namesortfunc):
      if bee_evexc(plug): 
        continue
      parent.import_plugin(self, plug)

    if nw:
      sockimp = [s[1:] for s in parent.socket_imports]
      for sock in self.socket_imports:
        if sock[0] is parent_old: continue
        if sock in sockimp: continue
        if bee_evexc(sock[2]): continue
        parent.import_socket(*sock)
      plugimp = [p[1:] for p in parent.plugin_imports]
      for plug in self.socket_imports:
        if plug[0] is parent_old: continue
        if plug in sockimp: continue
        if bee_evexc(plug[2]): continue
        parent.import_plugin(*plug)
    else:
      for sock in self.socket_imports:
        if sock[0] is parent: continue
        if sock in parent.socket_imports: continue
        if bee_evexc(sock[2]): continue
        report("SOCK-IMPORT-APPEND", self.contextname, sock[1], sock[2])
        parent.socket_imports.append(sock)

      for plug in self.plugin_imports:
        if plug[0] is parent: continue
        if plug in parent.plugin_imports: continue
        if bee_evexc(plug[2]): continue
        report("PLUG-IMPORT-APPEND", self.contextname, plug[1], plug[2])
        parent.plugin_imports.append(plug)

    if nw: parent.orig = None
      
  def parent_do_import(self):
    report("PARENT-DO-IMPORT", self.contextname)
    if self in networks: return
    from . import _contexts as contexts, get_curr_contextname, _all_connections
    if not self.import_all_from_parent: return   

    parent = None
    myname = self.contextname        
    while True:
      myname = myname[:-1]
      if not len(myname): break
      if myname in contexts:
        parent = contexts[myname]
        break
    if parent is None: return

    parent2 = parent
    parent_old = parent
    nw = False
    if parent in networks:
      nw = True     
      parent = networks[parent]
      parent2 = parent.contexts[-1]     

    #report("PARENT-IMPORT", self.contextname, parent_old.contextname)
    #report(list(parent.plugins.keys()), [p[2] for p in parent.plugin_imports])
    #report(list(parent.sockets.keys()), [p[2] for p in parent.socket_imports])
    #report("")

    for sock in sorted(parent.sockets,key=namesortfunc):
      if bee_evexc(sock):
        continue
      self.import_socket(parent2, sock)
    for plug in sorted(parent.plugins,key=namesortfunc):
      if bee_evexc(plug): 
        continue
      self.import_plugin(parent2, plug)

    for sock in parent.socket_imports:
      if nw: sock = sock[1:]
      if sock[0] is self: continue
      if sock in self.socket_imports: continue
      if bee_evexc(sock[2]): continue      
      report("SOCK-IMPORT-APPEND2", self.contextname, sock[1], sock[2])
      self.socket_imports.append(sock)

    for plug in parent.plugin_imports:
      if nw: plug = plug[1:]
      if plug[0] is self: continue
      if plug in self.plugin_imports: continue
      if bee_evexc(plug[2]): continue      
      report("PLUG-IMPORT-APPEND2", self.contextname, plug[1], plug[2])
      self.plugin_imports.append(plug)

  def do_connect(self):
    report("CONNECT", self.contextname)
    from . import _contexts as contexts, get_curr_contextname, _all_connections
    if not self.connection: return   
    #report("CONNECT", self.contextname)
    #report(self.plugins.keys(), [p[2] for p in self.plugin_imports])
    #report(self.sockets.keys(), [p[2] for p in self.socket_imports])
    #report("")

    parent = self.connection   
    for sock in sorted(parent.sockets,key=namesortfunc):
      if bee_evexc(sock): 
        continue
      self.import_socket(parent, sock)
    for plug in sorted(parent.plugins,key=namesortfunc):
      if bee_evexc(plug): 
        continue
      self.import_plugin(parent, plug)

    for sock in parent.socket_imports:
      if sock[0] is self: continue
      nam = sock[2]
      if bee_evexc(nam): 
        continue      
      report("SOCK-IMPORT-APPEND3", self.contextname, sock[1], sock[2])
      self.socket_imports.append(sock)

    for plug in parent.plugin_imports:
      if plug[0] is self: continue
      nam = plug[2]
      if bee_evexc(nam): 
        continue      
      report("PLUG-IMPORT-APPEND3", self.contextname, plug[1], plug[2])
      self.plugin_imports.append(plug)
   
  def close(self):
    if self.closed: return
    report("CLOSE", self.contextname)
    network(self)

    if self.subcontext != None: self.subcontext.__close__()     
    report("2CLOSE", self.contextname)
    if 0:
      report(self, self.contextname)
      report("CLOSE")
      report("PLUGINS")
      for p in self.plugins: report(p, self.plugins[p])
      report("SOCKETS")
      for s in self.sockets: report(s, self.sockets[s])
      report("PLUGIN-IMPORTS")
      for p in self.plugin_imports: report(p)
      report("SOCKET-IMPORTS")
      for s in self.socket_imports: report(s)
      report("/CLOSE")
      report("")
      report("")

    from . import _contexts as contexts, get_curr_contextname, _all_connections

    for f in self.preclose_functions:
      f()     

    myname = self.contextname     
    parent = None
    while True:
      myname = myname[:-1]
      if not len(myname): break
      if myname in contexts:
        parent = contexts[myname]
        break
    if parent:
      for s in self.import_parent_sockets:
        if retrieve_sockets(parent, s) is None:
          raise Exception("Context %s has required socket import %s from parent, but parent doesn't have that socket" % (myname, s))     
      for p in self.import_parent_plugins:
        if retrieve_plugins(parent, p) is None:
          raise Exception("Context %s has required plugin import %s from parent, but parent doesn't have that plugin" % (myname, p))
      if self.import_all_from_parent:   
        socks, plugs = [],[]
        if self not in networks:
          #print "CLOSE-FRAME", self.contextname
          def match(h1,h2):
            if isinstance(h1, str): h1 = (h1,)
            if isinstance(h2, str): h2 = (h2,)
            if len(h1) > len(h2):return False
            for hh1, hh2 in zip(h1,h2):
              if hh1 != hh2: return False
            return True
          def skipfilter(l):
            ret = []
            for x in l:
              for sk in self.import_parent_skip:
                if match(sk, x):
                  break
              else: ret.append(x)
            return ret

          newsocks = []
          for x in parent.socket_imports:
            xx = x[2]
            if bee_evexc(xx): continue
            if xx in newsocks: continue
            report("NEWSOCK", self.contextname, xx)
            newsocks.append(xx)

          newplugs = []
          for x in parent.plugin_imports:
            xx = x[2]
            if bee_evexc(xx): continue            
            if xx in newplugs: continue
            report("NEWPLUG", self.contextname, xx)
            newplugs.append(xx)
          
          socks0 = sorted(list(parent.sockets.keys()),key=namesortfunc)
          socks0 = [s for s in socks0 if not bee_evexc(s)]
          socks = skipfilter(socks0 + newsocks)
          plugs0 = sorted(list(parent.plugins.keys()),key=namesortfunc)
          plugs0 = [p for p in plugs0 if not bee_evexc(p)]
          plugs = skipfilter(plugs0 + newplugs)
      else:        
        if len(self.import_parent_sockets + self.import_parent_plugins):
          raise Exception("Context %s has required imports from parent, but doesn't have a parent" % myname)        
        socks = self.import_parent_sockets + self.import_parent_sockets_optional
        plugs = self.import_parent_plugins + self.import_parent_plugins_optional
      for s in socks:
        self.import_socket(parent, s, optional=True)
      for p in plugs:
        self.import_plugin(parent, p, optional=True)

    selfcontextname = encode_context(self.contextname)
    subcontextnames = [k for k in contexts.keys() if len(k) > len(selfcontextname) and k[:len(selfcontextname)] == selfcontextname]
    subcontextnames.sort(key = namesortfunc)  

    subcontexts = []
    for subcontextname in subcontextnames: 
      for n in range(len(selfcontextname)+1, len(subcontextname)):
        if subcontextname[:n] in contexts: break
      else:
        subcontexts.append(contexts[subcontextname])
    
    subcontextnames2 = [s.contextname for s in subcontexts]
    #if isinstance(self.contextname,str): report("SUBC", subcontextnames2)

    subcontextnames2.sort(key = namesortfunc)
    subcontexts = [contexts[n] for n in subcontextnames2]
    subcontexts.sort(key = lambda s: -s.priority)
    for s in subcontexts:
      s.parent_import()

    for s in subcontexts:
      s.parent_export()

    for s in subcontexts:       
      s.parent_import()
      s.do_connect()        

    #report("DO-CLOSE?", self.contextname)
    for s in subcontexts:       
      #report("@", s)
      s.close()    
      s.parent_do_export()

    #report("DO-CLOSE", self.contextname, len(self.plugin_imports))
    #report(self.plugin_imports)
    plugins_original0 = [self.plugins[p] for p in sorted(self.plugins,key=namesortfunc)]
    plugins_original = []
    for p in plugins_original0: plugins_original += p
    #report(1)
    
    newplugins = {}
    for p in self.plugin_imports:
      newname = p[2]
      if newname not in newplugins: newplugins[newname] = []
      report("NEWPLUG2", self.contextname, newname)
      newplugins[newname].append(p)
    count = 1
    for nwname in newplugins:       
      #report(count, nwname)
      count += 1
      currplugins = []    
      for contextinstance, name, newname, optional in newplugins[nwname]:        
        if name != None:
          #report("!", count, name, contextinstance.contextname)
          currplugins0 = retrieve_plugins(contextinstance, name)
          #report("!!")
          if currplugins0 is None:
           if not optional:
             report(
               [(a[0].contextname,)+a[1:] for a in self.plugin_imports], 
               [(a[0].contextname,)+a[1:] for a in self.socket_imports],
             )
             #report(contextinstance.plugins.keys())
             raise Exception("%s does not contain a plugin '%s'" % (contextinstance.contextname, name))
          else:
            #assert len(currplugins0) < 1000
            #report("###", len(currplugins), len(currplugins0))
            currplugins += currplugins0
        else: self.plugin(newname, None)
      #report(count, "@", len(currplugins))
      currplugins = list(set(currplugins))
      #report(count, "@@")
      currplugins.sort(key = namesortfunc2)       
      for cname, p in currplugins:
        if contextinstance is not self and p not in plugins_original: self.import_origins_plugins[p] = contextinstance
        if newname in self.plugins and p in self.plugins[newname]: continue
        self.plugin(newname, p)         

    #report("DO-CLOSE2", self.contextname, len(self.socket_imports))
    
    sockets_original0 = [self.sockets[p] for p in sorted(self.sockets,key=namesortfunc)]
    sockets_original = []
    for s in sockets_original0: sockets_original += s
    newsockets = {}
    for s in self.socket_imports:
      newname = s[2]
      if newname not in newsockets: newsockets[newname] = []
      report("NEWSOCK2", self.contextname, newname)
      newsockets[newname].append(s)
    for nwname in newsockets:
      currsockets = []
      for contextinstance, name, newname, optional in newsockets[nwname]:
        if name != None:
          currsockets0 = retrieve_sockets(contextinstance, name)
          if currsockets0 is None:
           if not optional:
             raise Exception("%s does not contain a socket '%s'" % (contextinstance.contextname, name))
          else:
            currsockets += currsockets0
        else: self.socket(newname, None)
      currsockets0 = []
      for c in currsockets: 
        if c not in currsockets0: currsockets0.append(c)
      currsockets = currsockets0

      currsockets.sort(key = namesortfunc2)
      for cname, s in currsockets:
        if contextinstance is not self and s not in sockets_original: self.import_origins_sockets[s] = contextinstance
        if newname in self.sockets and s in self.sockets[newname]: continue
        self.socket(newname, s)         

    #report("DO-CLOSE3", self.contextname)
    """
    if 0:
      print self, self.contextname
      print "CLOSE3"
      print "PLUGINS"
      for p in self.plugins: print p, self.plugins[p]
      print "SOCKETS"
      for s in self.sockets: print s, self.sockets[s]
      print "/CLOSE3"
      print ""
      print ""
    """
    #report("??ALLCLOSED", self.contextname)
    filled_sockets = set()
    pluginnames = list(self.plugins.keys())
    pluginnames.sort(key=namesortfunc)
    socketnames = list(self.sockets.keys())
    socketnames.sort(key=namesortfunc)     
    #report("?ALLCLOSED", self.contextname)
    for name in pluginnames:                       
      for p in self.plugins[name]:
        if name not in self.sockets \
         and p not in self.import_origins_plugins \
         and p != None:            
          try:
            p.unfilled()
          except Exception as e:
            raise type(e)(*(e.args + (self.contextname, name)))
          continue
        filled_sockets.add(name)
        try:      
          found_sockets = []
          if name in socketnames:
            found_sockets += self.sockets[name]
          if len(found_sockets):
            for s in found_sockets:
              if s == None: continue
              if p in self.import_origins_plugins: 
                if p == None: continue        
              if (s,p) in _all_connections:
                continue
              _all_connections.add((s,p))

              try:
                socketcontextname = s.function.im_self.workerinstance._context.contextname
                segmentname = s.function.im_self.segmentname
              except AttributeError:
                pass
              s.fill(*p.args, **p.kargs)
              p.fill(s)
        except Exception as e:               
          if python2: 
            e2 = type(e)(self.contextname, name, e.args)
            do_raise(e2)            
          else: raise Exception(self.contextname, name)
    for name in socketnames:
      if name in filled_sockets: continue
      try:
        for s in self.sockets[name]:             
          if s not in self.import_origins_sockets and s != None: 
            s.unfilled()
      except Exception as e:
        from . import add_contextnames
        raise type(e)(*(e.args + add_contextnames(self.contextname, name)))


    for f in self.postclose_functions:
      f()
    self._postclose()
    if get_curr_contextname() == self.contextname: pop()
    #report("ALLCLOSED", self.contextname)
    self.closed = True
    if self in networks and networks[self].contexts[-1] is self:
      p = {}
      for k in sorted(self.plugins,key=namesortfunc):
        if not bee_evexc(k): p[k] = self.plugins[k]
      s = {}
      for k in sorted(self.sockets,key=namesortfunc):
        if not bee_evexc(k): s[k] = self.sockets[k]
      for con in networks[self].contexts[:-1]:
        for k in p:
          if k not in con.plugins: con.plugins[k] = []
          con.plugins[k] += p[k]    
        for k in s:
          if k not in con.sockets: con.sockets[k] = []
          con.sockets[k] += s[k]    
 
     
  def socket(self, keyword, socketinstance):
    report("SOCKET", self.contextname, keyword)
    assert isinstance(socketinstance, socket_base) or socketinstance == None
    if keyword not in self.sockets: self.sockets[keyword] = []
    if socketinstance not in self.sockets[keyword]:
      self.sockets[keyword].append(socketinstance)    
  def plugin(self, keyword, pluginstance):
    report("PLUGIN", self.contextname, keyword)
    assert isinstance(pluginstance, plugin_base) or pluginstance == None
    if keyword not in self.plugins: self.plugins[keyword] = []
    if pluginstance not in self.plugins[keyword]:
      self.plugins[keyword].append(pluginstance)
  def preclose(self, preclose_function):
    self.preclose_functions.append(preclose_function)    
  def postclose(self, postclose_function):
    self.postclose_functions.append(postclose_function)
  def _postclose(self):
    pass
  
  def import_socket(self, contextinstance, name, newname = None, optional = False):  
    report("IMPORT-SOCKET", self.contextname, name, newname)  
    assert isinstance(contextinstance, context)
    assert contextinstance is not self
    if newname == None: newname = name
    n = (contextinstance, name, newname, optional)
    if n not in self.socket_imports:    
      self.socket_imports.append(n)    
    try:
      r = self.retrieved_sockets[newname]
      if r is None: r = []
      for c in contextinstance.retrieved_sockets[name]:
        if c not in r: r.append(c)
      if r: self.retrieved_sockets[newname] = r
    except KeyError:
      pass
  def import_plugin(self, contextinstance, name, newname = None, optional = False):  
    report("IMPORT-PLUGIN", self.contextname, name, newname)  
    assert isinstance(contextinstance, context)
    assert contextinstance is not self
    if newname == None: newname = name
    n = (contextinstance, name, newname, optional)
    if n not in self.plugin_imports:
      self.plugin_imports.append(n)    
    try:
      r = self.retrieved_plugins[newname]
      if r is None: r = []
      for c in contextinstance.retrieved_plugins[name]:
        if c not in r: r.append(c)
      if r: self.retrieved_plugins[newname] = r
    except KeyError:
      pass
      
  def export_socket(self, contextinstance, name, newname = None, optional = False):  
    report("EXPORT-SOCKET", self.contextname, name, newname)    
    assert isinstance(contextinstance, context)
    assert contextinstance is not self
    if newname == None: newname = name
    contextinstance.socket_imports.append((self, name, newname, optional))    
  def export_plugin(self, contextinstance, name, newname = None, optional = False):  
    report("EXPORT-PLUGIN", self.contextname, name, newname)    
    assert isinstance(contextinstance, context)
    assert contextinstance is not self
    if newname == None: newname = name
    contextinstance.plugin_imports.append((self, name, newname, optional))    
  
class connect:
  def __init__(self, socket, plugin):
    socketcontextname, socketname = socket
    plugincontextname, pluginname = plugin
    from . import add_contextnames, _contexts, get_curr_contextname
    socketcontextname = add_contextnames(get_curr_contextname(), socketcontextname)
    assert socketcontextname in _contexts, socketcontextname
    self.socketcontext = _contexts[socketcontextname]
    assert socketname in self.socketcontext.sockets
    self.socketname = socketname

    plugincontextname = add_contextnames(get_curr_contextname(), plugincontextname)    
    assert plugincontextname in _contexts, plugincontextname
    self.plugincontext = _contexts[plugincontextname]    
    assert pluginname in self.plugincontext.plugins    
    self.pluginname = pluginname

  def place(self):
    from . import new_abscontextname, add_contextnames
    newplugincontextname = new_abscontextname(add_contextnames(self.plugincontext.contextname, "<<connect"))
    newplugincontext = context(*newplugincontextname,absolute=True)
    
    newplugincontext.import_socket(self.socketcontext, self.socketname, self.pluginname)
    newplugincontext.import_plugin(self.plugincontext, self.pluginname)
    
    newsocketcontextname = new_abscontextname(add_contextnames(self.socketcontext.contextname, "<<connect"))
    newsocketcontext = context(*newsocketcontextname,absolute=True)
    
    newsocketcontext.import_socket(self.socketcontext, self.socketname)
    newsocketcontext.import_plugin(self.plugincontext, self.pluginname, self.socketname)
    return newplugincontext, newsocketcontext
    
    
class subcontext(object):
  def __init__(self, contextname, hive, import_parent_sockets = [], 
                                       import_parent_plugins = [], 
                                       import_parent_sockets_optional = [], 
                                       import_parent_plugins_optional = [],
                                       import_parent_skip = []):
    assert hive in (True, False)    
    self._contextname = decode_context(contextname)
    self._hive = hive
    self._make_context = False
    self._import_parent_sockets = import_parent_sockets
    self._import_parent_plugins = import_parent_plugins
    self._import_parent_sockets_optional = import_parent_sockets_optional
    self._import_parent_plugins_optional = import_parent_plugins_optional    
    self._import_parent_skip = import_parent_skip    
  def __place__(self):
    pass
  def make_context(self):
    from . import new_contextname  
    if not self._make_context:
      self._contextname = new_contextname(self._contextname)
      self.context = context(self._contextname)
      self.context.subcontext = self
      if not self._hive:
        self.context.import_all_from_parent = True
        assert not len(self._import_parent_sockets_optional), self._import_parent_sockets_optional
        assert not len(self._import_parent_plugins_optional), self._import_parent_plugins_optional
      self.context.import_parent_sockets = self._import_parent_sockets
      self.context.import_parent_plugins = self._import_parent_plugins
      self.context.import_parent_sockets_optional = self._import_parent_sockets_optional
      self.context.import_parent_plugins_optional = self._import_parent_plugins_optional 
      self.context.import_parent_skip = self._import_parent_skip
      self._make_context = True
  def place(self):
    from . import push, pop
    self.make_context()
    try:
      push(self._contextname)
      self.__place__()
    finally:
      pop()
  def __close__(self):
    pass
  def close(self):
    self.context.close()
    
